﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace WpfTest
{
    /// <summary>
    /// Logica di interazione per PrintSupport.xaml
    /// </summary>
    public partial class PrintSupport : Window, IDisposable
    {
        //private Steema.TeeChart.WPF.TChart t1;
        //private Steema.TeeChart.WPF.TChart t2;
        //private Steema.TeeChart.WPF.TChart t3;
        public PrintSupport()
        {
            InitializeComponent();
            BuildUI();
        }

        private void BuildUI()
        {
            //gridPage.RowDefinitions.Add(new RowDefinition());

            //gridPage.ColumnDefinitions.Add(new ColumnDefinition());
            //gridPage.ColumnDefinitions.Add(new ColumnDefinition());
            //gridPage.ColumnDefinitions.Add(new ColumnDefinition());

            //t1 = new Steema.TeeChart.WPF.TChart();
            //t2 = new Steema.TeeChart.WPF.TChart();
            //t3 = new Steema.TeeChart.WPF.TChart();



            //t1.SetValue(Grid.RowProperty, 0);
            //t2.SetValue(Grid.RowProperty, 0);
            //t3.SetValue(Grid.RowProperty, 0);

            //t1.SetValue(Grid.ColumnProperty, 0);
            //t2.SetValue(Grid.ColumnProperty, 1);
            //t3.SetValue(Grid.ColumnProperty, 2);




            Steema.TeeChart.Styles.Line line1 = new Steema.TeeChart.Styles.Line();
            Steema.TeeChart.Styles.Line line2 = new Steema.TeeChart.Styles.Line();
            Steema.TeeChart.Styles.Line line3 = new Steema.TeeChart.Styles.Line();

            t1.Series.Add(line1);
            t2.Series.Add(line2);
            t3.Series.Add(line3);


            t1.Series[0].FillSampleValues(20);
            t2.Series[0].FillSampleValues(200);
            t3.Series[0].FillSampleValues(48);

        }

        public void Print()
        {
            var prtDlg = new PrintDialog();

            //prtDlg.PrintVisual(this, "test");
            //return;

            FlowDocument doc = new FlowDocument();
            doc.Name = "Test";


            doc.PageHeight = (96 / 2.54) * 29.7;
            doc.PageWidth = (96 / 2.54) * 21;

            doc.ColumnWidth = doc.PageWidth;
            doc.ColumnGap = 0;

            var tb = new Table();
            var tgr = new TableRowGroup();

            var tr1 = new TableRow();

            tr1.Cells.Add(new TableCell(new Paragraph(new Run() { Text = "Pile Name", FontSize = 10, FontWeight = FontWeights.Bold })));
            tr1.Cells.Add(new TableCell(new Paragraph(new Run() { Text = "Geo TEs1", FontSize = 10 })));
            tr1.Cells.Add(new TableCell(new Paragraph(new Run() { Text = "Drilling Duration", FontSize = 10, FontWeight = FontWeights.Bold })));
            tr1.Cells.Add(new TableCell(new Paragraph(new Run() { Text = "0d 12h 15m 11s", FontSize = 10 })));
            tr1.Cells.Add(new TableCell(new Paragraph(new Run() { Text = "Start Timestamp", FontSize = 10, FontWeight = FontWeights.Bold })));
            tr1.Cells.Add(new TableCell(new Paragraph(new Run() { Text = "20/07/2022 12:48:02", FontSize = 10 })));

            tgr.Rows.Add(tr1);

            var tr = new TableRow();


            var s1 = new MemoryStream();
            var s2 = new MemoryStream();
            var s3 = new MemoryStream();

            var image1 = new BitmapImage();
            var image2 = new BitmapImage();
            var image3 = new BitmapImage();


            t1.Export.Image.PNG.Save(s1, t1.Bitmap((doc.PageWidth / 3 *2), doc.PageHeight), doc.PageWidth / 3, doc.PageHeight);
            t2.Export.Image.PNG.Save(s2, t2.Bitmap((doc.PageWidth / 3 * 2), doc.PageHeight), doc.PageWidth / 3, doc.PageHeight);
            t3.Export.Image.PNG.Save(s3, t3.Bitmap((doc.PageWidth / 3 * 2), doc.PageHeight), doc.PageWidth / 3, doc.PageHeight);

            t1.Export.Image.Bitmap.Height = double.NaN;
            t2.Export.Image.Bitmap.Height = double.NaN;
            t3.Export.Image.Bitmap.Height = double.NaN;

            t1.Export.Image.Bitmap.Width = double.NaN;
            t2.Export.Image.Bitmap.Width = double.NaN;
            t3.Export.Image.Bitmap.Width = double.NaN;

            RenderOptions.SetBitmapScalingMode(image1, BitmapScalingMode.HighQuality);
            RenderOptions.SetBitmapScalingMode(image2, BitmapScalingMode.HighQuality);
            RenderOptions.SetBitmapScalingMode(image3, BitmapScalingMode.HighQuality);

            image1.BeginInit();
            //image1.UriSource = new Uri(@"C:\Users\lavezzo\Desktop\t1.bmp");
            image1.CacheOption = BitmapCacheOption.OnLoad;
            s1.Position = 0;
            image1.StreamSource = s1;
            image1.EndInit();
            image2.BeginInit();
            //image2.UriSource = new Uri(@"C:\Users\lavezzo\Desktop\t2.bmp");
            s2.Position = 0;
            image2.CacheOption = BitmapCacheOption.OnLoad;
            image2.StreamSource = s2;
            image2.EndInit();
            image3.BeginInit();
            //image3.UriSource = new Uri(@"C:\Users\lavezzo\Desktop\t3.bmp");
            s3.Position = 0;
            image3.CacheOption = BitmapCacheOption.OnLoad;
            image3.StreamSource = s3;
            image3.EndInit();
            var block1 = new BlockUIContainer(new System.Windows.Controls.Image() { Source = image2 });
            var block2 = new BlockUIContainer(new System.Windows.Controls.Image() { Source = image2 });
            var block3 = new BlockUIContainer(new System.Windows.Controls.Image() { Source = image3 });

            tr.Cells.Add(new TableCell(block1) { ColumnSpan=2});
            tr.Cells.Add(new TableCell(block2) { ColumnSpan = 2 });
            tr.Cells.Add(new TableCell(block3) { ColumnSpan = 2 });

            
            tgr.Rows.Add(tr);
            tb.RowGroups.Add(tgr);

            doc.Blocks.Add(tb);


            IDocumentPaginatorSource idpSource = doc;
            prtDlg.PrintDocument(idpSource.DocumentPaginator, "Hello WPF Printing.");
        }

        //private void printClick(object sender, RoutedEventArgs e)
        //{
        //    var chartImage = GetImage(chart);
        //    var w = new Window { Content = chartImage };
        //    w.Show();
        //}

        //public static UIElement GetImage(RadCartesianChart chart,double width, double height)
        //{
        //    chart.Width = width;
        //    chart.Height = height;
        //    chart.OnApplyTemplate();
        //    chart.UpdateLayout();

        //    var stream = new MemoryStream();
        //    Telerik.Windows.Media.Imaging.ExportExtensions.ExportToImage(chart, stream, new PngBitmapEncoder());
        //    stream.Seek(0, SeekOrigin.Begin);
        //    var decoder = new PngBitmapDecoder(stream, BitmapCreateOptions.PreservePixelFormat, BitmapCacheOption.Default);
        //    var bitmapSource = decoder.Frames[0];
        //    var image = new Image { Source = bitmapSource };
        //    return image;
            
        //}

        public void Dispose()
        {
            t1.Series[0].Dispose();
            t2.Series[0].Dispose();
            t3.Series[0].Dispose();
            t1 = null;
            t2 = null;
            t3 = null;
        }
    }
}
